{****************************************************************************}
{*                                                                          *}
{*                              MegaPlay v.2.0                              *}
{*                           Digital Sample Player                          *}
{*                             Frozen Fire 1996                             *}
{*                                                                          *}
{****************************************************************************}
Program MegaPlay;
Uses CRT,DOS,MEM_MGR,MGPTXT,MGPSB;
var
   InpFile,Switch,Switch2,Tmp:string;
   i,pcnt:byte;
   w,Size,erc:word;
   Remn:word;
   ierc:integer;
   f:file;
   H:ExtHandle;
   FS,OS,Counter:Longint;
   OutX,alr,alr32,isPlaying,part,alf:boolean;
   OldTimer:procedure;
   DMAMem,DMAmem2:pointer;
   time_constant : word;
   page, offset: word;
   Zero,kp:pointer;

const
   { Starting settings }
   Freq:word=11025;
   FSet:boolean=FALSE;
   skp:boolean=FALSE;
   fdv:boolean=FALSE;
   ZSize=32767;
   DMAofs=16384;
   CountOfs=16384;
   MoveLen:word=16384;
   DMAchannel:byte=1;
   Sig1:string='Creative Voice File';
   Sig2:string='WAVEfmt';
   Tag:string='';

{****************************************************************************}
function FindMonoTC:byte;
var
   ftc,cfc:byte;
begin
cfc:=$18;
seek(f,cfc);
repeat
blockread(f,ftc,1);
inc(cfc);
until (ftc=1) or (cfc>$30);
if ftc=1 then
   begin
   seek(f,filepos(f)+3);
   blockread(f,ftc,1);
   FindMonoTC:=ftc;
   end else FindMonoTC:=0;
end;

procedure MakeZero;
begin
i:=$80;
for w:=0 to 16383 do
move(i,ptr(seg(Zero^),ofs(Zero^)+w)^,1);
end;

{$F+}
procedure NewTimer2;interrupt;
var
Remn:word;
Res:byte;
begin
asm
 in       al, 03
 mov      ah, al
 in       al, 03
 xchg     ah, al
 mov    Remn, ax
end;
if Remn=65535 then isPlaying:=FALSE;
inline($9C);
OldTimer;
end;


procedure NewTimer;interrupt;
var
Res:byte;
x:word;
begin
asm
 in       al, 03
 mov      ah, al
 in       al, 03
 xchg     ah, al
 mov    Remn, ax
end;
if alr and alr32 and not alf then
begin
if part then
begin
if (Remn<20000) and skp then
begin
alf:=true;
StopAll;
isPlaying:=FALSE;
skp:=false;
end;
if (Remn>16384) and not skp then
begin
skp:=TRUE;
end;
end
else
begin
if ((Remn>16384) or (Remn<4000)) and skp then
begin
alf:=true;
StopAll;
isPlaying:=FALSE;
skp:=false;
end;
if (Remn<16384) and not skp then
begin
skp:=TRUE;
end;
end;
end;

 if (Remn<16384) and not alr then
 begin
 alr:=true;
 alr32:=false;
 if FS-Counter=MoveLen then
  begin
  alr32:=true;
  alr:=true;
  part:=true;
  end;
 H.Offset:=Counter;
 MM_Move(DMAmem^,H,MoveLen,Extended,EMBtoUMB);
 inc(Counter,CountOfs);
 pcnt:=round(Counter/FS*100);
 gotoxy(22,yline);
 write(pcnt:3,'%');
 invis;
 end;
if (Remn>16384) and not alr32 then
 begin
 alr32:=true;
 alr:=false;
 if FS-Counter=MoveLen then
  begin
  alr32:=true;
  alr:=true;
  part:=false;
  end;
 H.Offset:=Counter;
 MM_Move(DMAmem2^,H,MoveLen,Extended,EMBtoUMB);
 inc(Counter,CountOfs);
 pcnt:=round(Counter/FS*100);
 gotoxy(22,yline);
 write(pcnt:3,'%');
 invis;
 end;
inline($9C);
OldTimer;
end;
{$F-}

BEGIN
alf:=FALSE;
Tmp:=GetEnv('BLASTER');
if pos('D',Tmp)<>0 then
 begin
 Switch:=copy(Tmp,pos('D',Tmp)+1,1);
 val(Switch,i,erc);
 if erc<>0 then DMAChannel:=i;
 end;
Intro;
case ParamCount of
0:
begin
{ No Parameters - too bad }
writeln('USAGE:');
writeln(' MEGAPLAY <filename> [switch1 [switch2]]');
writeln;
writeln(' <filename>   is the name of a RAW sample file');
writeln;
writeln(' [switch]');
writeln('    /S        Force Stereo output on SBPro cards, otherwise MONO is assumed');
writeln('    /F:[freq] where FREQ is the mixing frequency');
halt(0);
end;
1:
begin
{ The only parameter must be a FILENAME }
InpFile:=UCase(ParamStr(1));
end;
2:
begin
InpFile:=UCase(ParamStr(1));
Switch:=UCase(ParamStr(2));
if Switch='/S' then Stereo:=TRUE;
i:=pos('/F:',Switch);
if i>0 then
begin
Tmp:=Copy(Switch,i+3,length(Switch)-3);
val(Tmp,w,ierc);
if ierc=0 then
begin
Freq:=w;
FSet:=TRUE;
end;
end;
end;
3:
begin
InpFile:=UCase(ParamStr(1));
Switch:=UCase(ParamStr(2));
Switch2:=UCase(ParamStr(3));

if Switch='/S' then Stereo:=TRUE;

i:=pos('/F:',Switch);

if i>0 then
begin
Tmp:=Copy(Switch,i+3,length(Switch)-3);
val(Tmp,w,ierc);
if ierc=0 then
begin
Freq:=w;
FSet:=TRUE;
end;
end;

if Switch2='/S' then Stereo:=TRUE;

i:=pos('/F:',Switch2);

if i>0 then
begin
Tmp:=Copy(Switch2,i+3,length(Switch2)-3);
val(Tmp,w,ierc);
if ierc=0 then
begin
Freq:=w;
FSet:=TRUE;
end;
end;

end;
end; {case}

{ Try opening the file now }
assign(f,InpFile);
{$I-}
reset(f,1);
{$I+}
if IOresult<>0 then
begin
writeln('* Cannot open file ',InpFile);
halt(0);
end;
case DetectCard of
0:begin
  { PC Speaker - ?????? }
  writeln('* Sorry, no sound card was detected; Cannot play anything');
  halt(0);
  end;
1:begin
  writeln('* Sound Card       : SOUND BLASTER');
  if Stereo then
   begin
   writeln('  - cannot play STEREO;');
   Stereo:=FALSE;
   end;
  end;
2:begin
  writeln('* Sound Card       : SOUND BLASTER Pro');
  SBPro:=TRUE;
  end;
else
  begin
  writeln('* DetectCard = ',DetectCard);
  end;
end; {case 2}

if not XMSInstalled or (Init_MemMgr<>0) then
begin
writeln('* XMM driver is not installed;');
halt(0);
end;

FS:=FileSize(f);
if FS<$28 then
 begin
 writeln('* File must be bigger than ',$28,' bytes');
 halt(0);
 end;
{ Now check free XMS }
if not MM_Limit(0,(FS div 1024)+18) then
begin
writeln('* Not enough memory to load ',InpFile);
halt(0);
end;

GetMem(DMAmem,$FFF7);
GetMem(Zero,16384);
kp:=DMAmem;
DMAmem2:=ptr(seg(DMAmem^),ofs(DMAmem^)+DMAofs);

offset := Seg(DMAmem^) Shl 4 + Ofs(DMAmem^);
page := (Seg(DMAmem^) + Ofs(DMAmem^) shr 4) shr 12;

if $FFFF-offset<32767 then
begin
writeln('* DMA page override: PREVENTED');
DMAmem:=ptr(seg(DMAmem^),ofs(DMAmem^)+DMAofs*2-8);
DMAmem2:=ptr(seg(DMAmem^),ofs(DMAmem^)+DMAofs);
offset := Seg(DMAmem^) Shl 4 + Ofs(DMAmem^);
page := (Seg(DMAmem^) + Ofs(DMAmem^) shr 4) shr 12;
end;

if MM_Allocate(H,Extended,(FS div 1024)+17)<>0 then
begin
writeln('* Couldn''t allocate XMS;');
halt(0);
end;

time_constant := 256 - 1000000 div freq;

{ Detect file format }
blockread(f,Tmp[1],19);
Tmp[0]:=#19;
if Tmp=Sig1 then
 begin
 { This is a VOC file }
 Tag:='  -  Creative Voice File';
 seek(f,$21);
 blockread(f,i,1);
 if i=1 then
  begin
  if SBPro then Stereo:=TRUE;
  seek(f,$1F);
  blockread(f,i,1);
  if not FSet then
   begin
   time_constant:=i;
   Freq:=round(1000000/(256 - time_constant)) shr 1;
   end;
  end
  else
  begin
  if not FSet then
  begin
  time_constant:=FindMonoTC;
  Freq:=round(1000000/(256 - time_constant));
  end;
  end;
 FindMonoTC;
 Seek(f,filepos(f)+1);
 FS:=FS-filepos(f); { Set end-of-VOC-header position }
 end
 else
 begin
 seek(f,8);
 blockread(f,Tmp[1],7);
 Tmp[0]:=#7;
 if Tmp=Sig2 then
 begin
 { This is a WAV file }
 Tag:='  -  RIFF WAVE File';
 seek(f,$16);
 blockread(f,w,2);
 if w=2 then
  begin
  if SBPro then Stereo:=TRUE;
  seek(f,$18);
  blockread(f,w,2);
  if not FSet then
   begin
   Freq:=w;
   time_constant:=256 - 1000000 div (2*freq);
   end;
  end
  else
  begin
  seek(f,$18);
  blockread(f,w,2);
  if not FSet then
   begin
   Freq:=w;
   time_constant:=256 - 1000000 div freq;
   end;
  end;
 Seek(f,$2C);
 FS:=FS-$2C; { Set end-of-WAV-header position }
 end
 else
 Seek(f,0);
 end;
  writeln('* Time Constant    : ',time_constant);
{ Now indicate the data }
writeln('* Mixing Frequency : ',Freq);
if Stereo then writeln('* Output Mode      : STEREO') else
   writeln('* Output Mode      : MONO');
writeln('* Sample File      : ',InpFile,Tag);

MakeZero;

{ Now load the file into XMS }
yline:=wherey;
OS:=FS;
pcnt:=0;
write('* Loading Sample   : ');
OutX:=FALSE;
OS:=0;
repeat
if FS>OS then
begin
if FS-OS<$FA00 then
begin
Size:=FS-OS;
OutX:=TRUE;
end else Size:=$FA00;
blockread(f,MemoryBuffer^,Size,erc);
if erc<>size then
begin
writeln('* Error while reading file ',InpFile);
Done_MemMgr;
halt(0);
end;
H.Offset:=OS;
MM_Move(MemoryBuffer^,H,Size,Extended,UMBtoEMB);
inc(OS,Size);
pcnt:=round(OS/FS*100);
gotoxy(22,yline);
write(pcnt:3,'%');
invis;
end else OutX:=TRUE;
until OutX;
pcnt:=0;
H.Offset:=OS;
MM_Move(Zero^,H,16384,Extended,UMBtoEMB);
if FS>zsize+1 then FS:=FS+16384-(FS mod 16384);
if SBPro then SetOutMode(Stereo);
Speaker(True);
Counter:=Zsize+1;
GetIntVec($8,@OldTimer);
H.Offset:=0;
MM_Move(DMAmem^,H,zsize+1,Extended,EMBtoUMB);
if SBPro then SetVolume($FF);

{ PlayBack }

if FS<zsize+1 then
begin
ResetDSP;
WriteDAC($FF);

PlayBack(DMAmem,FS,time_constant);
SetIntVec($8,addr(NewTimer2));
isPlaying:=TRUE;
end
else
begin
  { Set the playback frequency }
  WriteDSP($40);
  WriteDSP(time_constant);

  WriteDSP($48);
  WriteDSP(Lo(zsize));
  WriteDSP(Hi(zsize));

  { Set up the DMA chip }
  Port[$0A] := 4 or DMAChannel;
  Port[$0C] := 0;
  Port[$0B] := $58 or DMAChannel;
  Port[$02] := Lo(offset);
  Port[$02] := Hi(offset);
  Port[$83] := page;
  Port[$03] := Lo(zsize);
  Port[$03] := Hi(zsize);
  Port[$0A] := DMAChannel;
  { Set the playback type (Auto-Init 8-bit) }
  WriteDSP($1C);
alr:=false;
alr32:=true;
isPlaying:=TRUE;
SetIntVec($8,addr(NewTimer));
end;
if FS<zsize+1 then pcnt:=100 else pcnt:=round(Counter/FS*100);
gotoxy(1,yline);
write('* Playing Sample   : ',pcnt:3,'%');
invis;

OutX:=FALSE;
repeat
if keypressed then
   begin
   readkey;
   OutX:=True;
   If SBPro then FadeVol($FF);
   end;
if not isPlaying then OutX:=TRUE;
until OutX;

if not Toff then StopAll;
gotoxy(22,yline);
writeln('Done');
SetIntVec($8,addr(OldTimer));
MM_FreeMem(H,Extended);
Done_MemMgr;
FreeMem(kp,$FFF7);
SetVolume($BB);
SetOutMode(false);
textcolor(7);
END.